ti = 0;
vs = 40;
tauk = 5; %Cambiar también dentro de la funcion de histeresis_model
gH = 1.6*10^-6;
gL = 0.5*10^-6;
Cm = 1*10^-9;
Vm = 0.1;
V1 = 2;
lamda_ini = 0;
Rs = 250000;
Vs = 0.7;
Vr = -0.4;
ns = 1;
nr = 1;
nt = (1/ns + 1/nr)^-1;
vt = (Vs/ns + Vr/nr)*nt;
I_tot = simulate_histeresis(vs,ti,tauk,gH,gL,Cm,Vm,V1,lamda_ini,Rs,Vs,Vr,ns,nr,nt,vt);
%plot (t, V_tot);
%funciones
function V = u(vs,t,ti)
    V = vs*t + -vs*ti;
    % Parámetros de la señal senoidal

end

function dlamdadt = histeresis_model(t,lamda,vs,ti,Vs,Vr,ns,nr,Vm)
    tauk = 5; %Introducir el mismo valor dentro de la función
    taus = tauk*exp(-(u(vs, t, ti)-Vs)/(ns*Vm));
    taur = tauk*exp((u(vs, t, ti)-Vr)/(nr*Vm));
    taut = (1/taus + 1/taur)^-1;
    dlamdadt = (1-lamda)./(taus) - lamda./(taur);
    
end

function I = simulate_histeresis (vs,ti,tauk,gH,gL,Cm,Vm,V1,lamda_ini,Rs,Vs,Vr,ns,nr,nt,vt)
    % Step 1
    tr1 = linspace(ti, ti + (V1 - 0) / vs, 1000);
    u1 = u(vs, tr1, ti);
    dudt = vs;
    % Resuelve las ecuaciones diferenciales
    options = odeset('RelTol', 1e-8, 'AbsTol', 1e-10);
    taus1 = tauk*exp(-(u1-Vs)/(ns*Vm));
    taur1 = tauk*exp((u1-Vr)/(nr*Vm));
    taut1 = (1./taus1 + 1./taur1).^-1;
    [T1, LAMDA1] = ode45(@(t, lamda) histeresis_model(t, lamda, vs, ti,Vs,Vr,ns,nr,Vm), tr1, lamda_ini, options);
    lamda1 = LAMDA1(:, 1);
    I1 = (gL+(gH-gL)*lamda1').*u1 + Cm*dudt;
    % En el steady state
    lamdass1 = 1./(1+exp(-(u1-vt)/(nt*Vm)));
    B1 = 1/Vm * ((1-lamdass1)./(ns*taus1) + lamdass1./(nr*taur1));
    gb1 = gL+(gH-gL).*lamdass1;
    ga1 = B1.*(gH-gL).*taut1.*u1;
    La1 = taut1./ga1;
    Idc_1 = (gL+(gH-gL)*lamdass1).*u1;
    Vapp1 = Idc_1*Rs+u1;
    Ifast1 = Vapp1/(Rs+gL^-1);
    % Asigna el resultado a la variable de salida
    I = I1;
    
    %Step 2
   vs = -vs;
   tr2 = linspace (tr1(end),tr1(end) + (0-V1)/vs,1000);
   u2 = u(vs,tr2,tr2(end));
   taus2 = tauk*exp(-(u2-Vs)/(ns*Vm));
   taur2 = tauk*exp((u2-Vr)/(nr*Vm));
   taut2 = (1./taus2 + 1./taur2).^-1;
   dudt = vs; 
   options = odeset('RelTol', 1e-8, 'AbsTol', 1e-10);
   [T2, LAMDA2] = ode45(@(t, lamda) histeresis_model(t, lamda, vs, tr2(end),Vs,Vr,ns,nr,Vm), tr2, lamda1(end), options);
   lamda2 = LAMDA2(:,1);
  
   I2 = (gL+(gH-gL)*lamda2').*u2 + Cm*dudt;
   %En el steady state
   lamdass2 = 1./(1+exp(-(u2-vt)/(nt*Vm)));
   Idc_2 = (gL+(gH-gL)*lamdass2).*u2;
   Vapp2 = Idc_2*Rs+u2;
   Ifast2 = Vapp2/(Rs+gL^-1);
    % Asigna el resultado a la variable de salida
   I = I2;
  
   B2 = 1/Vm* ((1-lamdass2)./(ns*taus2) + lamdass2./(nr*taur2));
   gb2 = gL+(gH-gL).*lamdass2;
   ga2 = B2.*(gH-gL).*taut2.*u2;
   La2 = taut2./ga2;

   %Step 3
    
   tr3 = linspace (tr2(end),tr2(end) + (0-V1)/(vs),1000);
   u3 = u(vs,tr3,tr3(1));
   dudt = vs;
   taus3 = tauk*exp(-(u3-Vs)/(ns*Vm));
   taur3 = tauk*exp((u3-Vr)/(nr*Vm));
   taut3 = (1./taus3 + 1./taur3).^-1;
   options = odeset('RelTol', 1e-8, 'AbsTol', 1e-10);
   [T3, LAMDA3] = ode45(@(t, lamda) histeresis_model(t, lamda, vs, tr3(1),Vs,Vr,ns,nr,Vm), tr3, lamda2(end), options);
   lamda3 = LAMDA3(:,1);
   I3 = (gL+(gH-gL)*lamda3').*u3 + Cm*dudt;
   %En el steady state
   lamdass3 = 1./(1+exp(-(u3-vt)/(nt*Vm)));
   Idc_3 = (gL+(gH-gL)*lamdass3).*u3;
   Vapp3 = Idc_3*Rs+u3;
   Ifast3 = Vapp3/(Rs+gL^-1);
   % Asigna el resultado a la variable de salida
   I = I3;

   B3 = 1/Vm* ((1-lamdass3)./(ns*taus3) + lamdass3./(nr*taur3));
   gb3 = gL+(gH-gL).*lamdass3;
   ga3 = B3.*(gH-gL).*taut3.*u3;
   La3 = taut3./ga3;
   %Step 4
   vs = -vs;
   tr4 = linspace (tr3(end),tr3(end) + (V1)/(vs),1000);
   u4 = u(vs,tr4,tr4(end));
   taus4 = tauk*exp(-(u4-Vs)/(ns*Vm));
   taur4 = tauk*exp((u4-Vr)/(nr*Vm));
   taut4 = (1./taus4 + 1./taur4).^-1;
   dudt = vs;
   options = odeset('RelTol', 1e-8, 'AbsTol', 1e-10);
   [T4, LAMDA4] = ode45(@(t, lamda) histeresis_model(t, lamda, vs, tr4(end),Vs,Vr,ns,nr,Vm), tr4, lamda3(end), options);
   lamda4 = LAMDA4(:,1); %se obtiene un vector con el valor de w con el tiempo
   I4 = (gL+(gH-gL)*lamda4').*u4 + Cm*dudt;
   %En el steady state
   lamdass4 = 1./(1+exp(-(u4-vt)/(nt*Vm)));
   Idc_4 = (gL+(gH-gL)*lamdass4).*u4;
   Vapp4 = Idc_4*Rs+u4;
   Ifast4 = Vapp4/(Rs+gL^-1);
   % Asigna el resultado a la variable de salida
   I = I4;
   B4 = 1/Vm* ((1-lamdass4)./(ns*taus4) + lamdass4./(nr*taur4));
   gb4 = gL+(gH-gL).*lamdass4;
   ga4 = B4.*(gH-gL).*taut4.*u4;
   La4 = taut4./ga4;

% Organizar datos en columnas separadas
% u_datos = [u1', u2', u3', u4'];
% I_datos = -[I1', I2', I3', I4'];
% I_dc_datos = [Idc_1', Idc_2', Idc_3', Idc_4'];
% I_fast = [Ifast1', Ifast2', Ifast3', Ifast4'];
% lamdass = -[lamdass1', lamdass2', lamdass3', lamdass4'];
% lamda = -[lamda1', lamda2', lamda3',lamda4'];
% taur_datos = [log(taur1)', log(taur2)', log(taur3)', log(taur4)'];
% taus_datos = [log(taus1)', log(taus2)', log(taus3)', log(taus4)'];
% taut_datos = [log(taut1)', log(taut2)', log(taut3)', log(taut4)'];
% % Combina todos los datos de 'u' en una sola columna
% u_combinado = u_datos(:);
% 
% % Combina todos los datos de 'I_tot' en una sola columna
% I_combinado = I_datos(:);
% I_dc_combinado = I_dc_datos(:);
% I_fast_combinado = I_fast(:);
% lamdass_combinado = lamdass(:);
% lamda_combinado = lamda(:);
% taur_combinado = taur_datos(:);
% taus_combinado = taus_datos(:);
% taut_combinado = taut_datos(:);
% % Crear una tabla con las dos columnas
% tabla_resultados = table(u_combinado, I_combinado, I_dc_combinado, I_fast_combinado, lamdass_combinado, lamda_combinado,taur_combinado,taus_combinado,taut_combinado, 'VariableNames', {'u', 'I_tot', 'I_dc','I_fast','lamdass','lamda','taur','taus','taut'});
% 
% %Guardar la tabla en un archivo Excel
% nombre_archivo_excel = 'resultados_simulacion_hysteresis_miranda.xlsx';
% writetable(tabla_resultados, nombre_archivo_excel, 'Sheet', 'Datos', 'WriteMode', 'overwrite');
    %plot (linspace (-V1*1,V1*1),linspace (0,0),'black');
    hold on
    %plot (linspace (0,0), linspace (-1,1),'black');
   %plot (u1,Idc_1, 'LineWidth', 1, 'DisplayName', 'I_dc');
   %  % legend('Location', 'best');
   % plot(u1, Idc_1, 'LineWidth', 1, 'Color', [1, 0, 1]);
   % plot(u2, Idc_2, 'LineWidth', 1, 'Color', [1, 0, 1]);
   % plot(u3, Idc_3, 'LineWidth', 1, 'Color', [1, 0, 1]);
   % plot(u4, Idc_4, 'LineWidth', 1, 'Color', [1, 0, 1]);
   % % plot(u1, Ifast1, 'LineWidth', 1, 'Color', [1, 0, 0]);
   % % plot(u2, Ifast2, 'LineWidth', 1, 'Color', [1, 0, 0]);
   % % plot(u3, Ifast3, 'LineWidth', 1, 'Color', [1, 0, 0]);
   % % plot(u4, Ifast4, 'LineWidth', 1, 'Color', [1, 0, 0]);
   % plot(u1, I1, 'LineWidth', 1,'Color', [1, 0, 0]);%Roig
   % plot(u2, I2, 'LineWidth', 1,'Color', [1, 1, 0]);%groc
   % plot(u3, I3, 'LineWidth', 1,'Color', [1, 0, 0]);%roig
   % plot(u4, I4, 'LineWidth', 1,'Color', [1, 1, 0]);%groc

   % plot(u1, lamdass1, 'LineWidth', 1, 'Color', [0, 1, 0]);
   % plot(u2, lamdass2, 'LineWidth', 1, 'Color', [0, 1, 0]);
   % plot(u3, lamdass3, 'LineWidth', 1, 'Color', [0, 1, 0]);
   % plot(u4, lamdass4, 'LineWidth', 1, 'Color', [0, 1, 0]);

   % plot(u1, lamda1, 'LineWidth', 1, 'Color', [1, 0, 0]);
   % plot(u2, lamda2, 'LineWidth', 1, 'Color', [1, 1, 0]);
   % plot(u3, lamda3, 'LineWidth', 1, 'Color', [1, 0, 0]);
   % plot(u4, lamda4, 'LineWidth', 1, 'Color', [1, 1, 0]);

   plot(u1, log(taus1), 'LineWidth', 1, 'Color', [1, 0, 0]);
   plot(u2, log(taus2), 'LineWidth', 1, 'Color', [1, 0, 0]);
   plot(u3, log(taus3), 'LineWidth', 1, 'Color', [1, 0, 0]);
   plot(u4, log(taus4), 'LineWidth', 1, 'Color', [1, 0, 0]);

   plot(u1, log(taur1), 'LineWidth', 1, 'Color', [1, 0, 1]);
   plot(u2, log(taur2), 'LineWidth', 1, 'Color', [1, 0, 1]);
   plot(u3, log(taur3), 'LineWidth', 1, 'Color', [1, 0, 1]);
   plot(u4, log(taur4), 'LineWidth', 1, 'Color', [1, 0, 1]);
   % % 
   plot(u1, log(taut1), 'LineWidth', 1, 'Color', [0, 0, 1]);
   plot(u2, log(taut2), 'LineWidth', 1, 'Color', [0, 0, 1]);
   plot(u3, log(taut3), 'LineWidth', 1, 'Color', [0, 0, 1]);
   plot(u4, log(taut4), 'LineWidth', 1, 'Color', [0, 0, 1]);

   % 
   % plot(u1, ga1, 'LineWidth', 1,'Color', [1, 0, 0]);%Roig
   % plot(u2, ga2, 'LineWidth', 1,'Color', [1, 0, 0]);
   % plot(u3, ga3, 'LineWidth', 1,'Color', [1, 0, 0]);%roig
   % plot(u4, ga4, 'LineWidth', 1,'Color', [1, 0, 0]);
   % % 
   % plot(u1, gb1, 'LineWidth', 1,'Color', [1, 0, 1]);%lila
   % plot(u2, gb2, 'LineWidth', 1,'Color', [1, 0, 1]);
   % plot(u3, gb3, 'LineWidth', 1,'Color', [1, 0, 1]);
   % plot(u4, gb4, 'LineWidth', 1,'Color', [1, 0, 1]);
   % % 
   % plot(u1, La1, 'LineWidth', 1,'Color', [1, 0, 0]);%Roig
   % plot(u2, La2, 'LineWidth', 1,'Color', [1, 1, 0]);%groc
   % plot(u3, La3, 'LineWidth', 1,'Color', [1, 0, 0]);%roig
   % plot(u4, La4, 'LineWidth', 1,'Color', [1, 1, 0]);%groc

   % plot(u1, B1, 'LineWidth', 1,'Color', [1, 0, 0]);%Roig
   % plot(u2, B2, 'LineWidth', 1,'Color', [1, 1, 0]);%groc
   % plot(u3, B3, 'LineWidth', 1,'Color', [1, 0, 0]);%roig
   % plot(u4, B4, 'LineWidth', 1,'Color', [1, 1, 0]);%groc



   % plot(tr1, u1, 'LineWidth', 1, 'Color', [1, 0, 0]); 
   % plot(tr2, u2, 'LineWidth', 1, 'Color', [1, 0, 0]);
   % plot(tr3, u3, 'LineWidth', 1, 'Color', [1, 0, 0]);
   % plot(tr4, u4, 'LineWidth', 1, 'Color', [1, 0, 0]);

end

