ti = 0;
vs = 1;
tauk = 50; %Cambiar también dentro de la funcion de histeresis_model
tf = 10;
tr1 = linspace(ti, tf, 10000);
gH = 0.7*10^-6*ones(size(tr1));
gL = 0.1*10^-6*ones(size(tr1));
Cm = 0.01*10^-6*ones(size(tr1)); %Cm = 0.01 para los pulsos inductivos
Vm = 0.1;
V1 = 2;
lamda_ini = [0,0];
Rs = 2000000*ones(size(tr1));
Vs = 0.4;
Vr = -0.7;
ns = 4;
nr = 4;
nt = (1/ns + 1/nr)^-1;
vt = (Vs/ns + Vr/nr)*nt;
I_tot = simulate_histeresis(ti,tf,tr1,tauk,gH,gL,Cm,Vm,V1,lamda_ini,Rs,Vs,Vr,ns,nr,nt,vt);
    
function V = Voltage (V1,t,ti,tf, pulse_width, pulse_period)
    frecuencia = 1 / pulse_period;
   % Determinar el tiempo en la mitad del periodo
    mitad_periodo = (ti + tf) / 2;
    ti_positivo = ti;
    ti_negativo = ti_positivo+tf/2+pulse_width;
    % Generar secuencia de pulsos positivos y negativos
    pulso_positivo = V1 * (mod(t - ti_positivo, pulse_period) >= pulse_width & t <= mitad_periodo);
    pulso_negativo = -V1 * (mod(t - ti_negativo, pulse_period) < pulse_width & t > mitad_periodo);

    %Combinar los pulsos positivos y negativos
    V = pulso_positivo + pulso_negativo;
    %V = -V1 * (mod(t - ti, pulse_period) >= pulse_width);
    % V = V1 * sin(2*pi*frecuencia*t);
    %V = V1;

end

function dlamdadt = histeresis_model(t,lamda,ti,tf,V1,Vs,Vr,ns,nr,Vm,tauk,pulse_width, pulse_period,gL,gH,Cm,Rs)
    Vapplied = Voltage(V1, t, ti, tf, pulse_width, pulse_period);
    u = lamda(2);
    lamda1 = lamda(1);
    dlamdadt1 = [];
    dudt = [];

   for i = 1:length(t)
    taus = tauk*exp(-(u(i)-Vs)/(ns*Vm));
    taur = tauk*exp((u(i)-Vr)/(nr*Vm));
    dlamdadt1 = (1-lamda1(i))/(taus(i)) - lamda1(i)/taur(i);
    dudt = 1/Cm(i)* ((Vapplied(i) - u(i))/Rs(i) - (gL(i)+(gH(i)-gL(i))*lamda1(i))*u(i));
   % Ajustar dimensiones si es necesario
    %disp(size(Vapplied));
    %disp(size(dxdt1));
    % disp(size(dudt));
    disp(['Dimensiones de dlamdadt1: ', num2str(size(dlamdadt1))]);
    disp(['Dimensiones de dudt: ', num2str(size(dudt))]);

    % Concatenar de manera explícita
    dlamdadt = [dlamdadt1; dudt];
    end
end

function I = simulate_histeresis (ti,tf,tr1,tauk,gH,gL,Cm,Vm,V1,lamda_ini,Rs,Vs,Vr,ns,nr,nt,vt)
RL = gL.^-1;
RH = gH.^-1;
    pulse_width = 0.25;
    pulse_period = 0.5;
    % Step 1
    % Genera el tren de pulsos
    Vapp1 = Voltage(V1, tr1, ti,tf, pulse_width, pulse_period);

        disp(['Dimensiones de Vapp1: ', num2str(size(Vapp1))]);
        disp(['Dimensiones de Rs: ', num2str(size(Rs))]);
        
        options = odeset('RelTol', 1e-6, 'AbsTol', 1e-6);
            
        [T1, LAMDA1] = ode15s(@(t, lamda) histeresis_model(t,lamda,ti,tf,V1,Vs,Vr,ns,nr,Vm,tauk,pulse_width, pulse_period,gL,gH,Cm,Rs), tr1, lamda_ini, options);
        lamda1 = LAMDA1(:, 1)';
        u1 = LAMDA1(:, 2)';
        lamdass1 = 1./(1+exp(-(u1-vt)/(nt*Vm)));
        udc = Vapp1.*(((RH.*RL)./(RH+RL))./(Rs+(RH.*RL)./(RH+RL)));
        dudt1 = 1./Cm.* ((Vapp1 - u1)./Rs -((gL+(gH-gL).*lamda1).*u1));
        I1 = (gL+(gH-gL).*lamda1).*u1 + Cm.*dudt1;
        %I1 = (gL+(gH-gL).*lamda1).*u1;
        % Ajusta el tamaño de tr1
        %tr1_plot = linspace(ti, ti + (V1 - 0) / vs, length(X1));
    
        % En el steady state
        Idc_1 = Vapp1./(Rs+(gL+(gH-gL).*lamdass1).^-1);
        Ifast_1 = Vapp1./(Rs+gL.^-1);
        %Idc_1 = (gL+(gH-gL).*lamdass1).*udc;
        %Idc_1 = udc./(RH.^-1 + RL.^-1).^-1;
        I = I1;
        % 


    %Organizar datos en columnas separadas
u_datos = [u1'];
t_datos = [tr1];
I_datos = [I1'];
I_dc_datos = [Idc_1'];
I_fast_datos = [Ifast_1'];
% Combina todos los datos de 'u' en una sola columna
u_combinado = u_datos(:);

% Combina todos los datos de 'I_tot' en una sola columna
I_combinado = I_datos(:);
I_dc_combinado = I_dc_datos(:);
t_combinado = t_datos(:);
I_fast_combinado = I_fast_datos(:);
% Crear una tabla con las dos columnas
tabla_resultados_pulsos_Rs_variable = table(u_combinado, I_combinado, I_dc_combinado,I_fast_combinado, t_combinado, 'VariableNames', {'u', 'I_tot', 'I_dc','I_fast','t'});
% Guardar la tabla en un archivo Excel
nombre_archivo_excel = 'resultados_simulacion_pulsos_miranda.xlsx';
writetable(tabla_resultados_pulsos_Rs_variable, nombre_archivo_excel, 'Sheet', 'Datos', 'WriteMode', 'overwrite');


   
    % Graficar la primera curva y especificar el estilo de línea y ancho
   plot(tr1, I1, 'LineWidth', 1, 'DisplayName', 'I_t_o_t');
   hold on 
   plot(tr1, Idc_1);
   plot(tr1,Ifast_1);
    %plot (tr1, u1);
    % plot (tr1, lamda1*10^-6);
    % plot (tr1, dudt1);
    %plot (tr1,Vapp1);
  

    % Graficar la segunda curva con un estilo de línea diferente
    %plot(tr1, Idc_1, 'LineWidth', 1, 'DisplayName', 'I_d_c_1');

    % Agregar títulos y leyenda
    title('Graph of total current (Potentiation)');
    xlabel('Time (s)');
    ylabel('I(A)');
    %legend('show'); 
    % Mostrar la leyenda
    %
    % plot (tr1,(gL+(gH-gL).*lamda1).*u1,'LineWidth', 1);
    % hold on
    %plot (tr1,Cm.*dudt1,'LineWidth', 1);
    %plot (tr1,Idc_1,'LineWidth', 1);
    %plot (tr1,U1);
    % plot (tr1,u1);
    % hold on
    % plot (tr1,udc);
    %plot (tr1,Vapp1);
    %plot (u1,lamdass1);
    %plot(tr1, dudt1, 'LineWidth', 1, 'Color', [1, 0, 0]);
    %plot(tr1_plot, u1, 'LineWidth', 1, 'Color', [0, 0, 1]);
    % plot(tr3, I3, 'LineWidth', 1, 'Color', [1, 0, 0]);
    % plot(tr4, I4, 'LineWidth', 1, 'Color', [0, 0, 1]);

end

